##
## Picon renderer by Gruffy
##
from Renderer import Renderer
from enigma import ePixmap
from Tools.Directories import SCOPE_SKIN_IMAGE, resolveFilename
from Tools.Directories import fileExists
import os
from os import listdir


class Picon(Renderer):
	def __init__(self):
		Renderer.__init__(self)
		
		self.searchPaths = [	'/etc/picon/', 
					'/media/cf/picon/',
					'/media/usb/picon/',
					'/media/hdd/picon/']

	GUI_WIDGET = ePixmap

	def changed(self, what):
		try:
			if what[0] == self.CHANGED_CLEAR:
				pngname = self.findPicon("picon_default")
			else:
				pngname = self.findPicon(self.source.text)
				if pngname == "":
					pngname = self.findPicon("picon_default")
				self.instance.setPixmapFromFile(pngname)
		except:
			print "Sorry...but Picon failed..."	
	
	def findPicon(self, serviceName):
		for path in self.searchPaths:
			png = self.findFile(path, serviceName)
			if png != "":
				return png
			
		return ""
	

	def findFile(self, path, serviceName):
		pngname = path + serviceName + ".png"
		if fileExists(pngname):
			return pngname
		else:
			for i in range(len(serviceName), 1, -1):
				if fileExists(path + serviceName[0:i] + ".png"):
					return path + serviceName[0:i] + ".png"
			return ""
		
			
			
			